Index: branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/Application.cs
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/Application.cs	(revision 4979)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/Application.cs	(revision 5257)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab 
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * 
+ * This file is part of HeuristicLab. 
+ * 
+ * HeuristicLab is free software: you can redistribute it and/or modify 
+ * it under the terms of the GNU General Public License as published by 
+ * the Free Software Foundation, either version 3 of the License, or 
+ * (at your option) any later version. 
+ * 
+ * HeuristicLab is distributed in the hope that it will be useful, 
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+ * GNU General Public License for more details. 
+ * 
+ * You should have received a copy of the GNU General Public License 
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>. 
+ */
+#endregion
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -5,28 +25,9 @@
 using System.Runtime.Serialization;
 
-namespace HeuristicLab.Services.Authentication.DataTransfer
-{
+namespace HeuristicLab.Services.Authentication.DataTransfer {
+
   [DataContract]
-  public class Application : NamedAuthenticationItem {
-    
-    
-    
-    //[DataMember]
-    //public string LoweredApplicationName { get; set; } // !!! REMOVE
+  public class Application : AuthenticationItem {
+  }
 
-    [DataMember]
-    public string Description { get; set; }
-
-  }
-    //[DataContract]
-    //public class Application : NamedAuthItem {
-    //    [DataMember]
-    //    public Guid ApplicationId { get; set; }
-    //    [DataMember]
-    //    public string ApplicationName { get; set; }
-    //    [DataMember]
-    //    public string LoweredApplicationName { get; set; }
-    //    [DataMember]
-    //    public string Description { get; set; }
-    //}
 }
Index: branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/AuthenticationItem.cs
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/AuthenticationItem.cs	(revision 4979)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/AuthenticationItem.cs	(revision 5257)
@@ -1,12 +1,37 @@
-﻿using System.Runtime.Serialization;
+﻿#region License Information
+/* HeuristicLab 
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * 
+ * This file is part of HeuristicLab. 
+ * 
+ * HeuristicLab is free software: you can redistribute it and/or modify 
+ * it under the terms of the GNU General Public License as published by 
+ * the Free Software Foundation, either version 3 of the License, or 
+ * (at your option) any later version. 
+ * 
+ * HeuristicLab is distributed in the hope that it will be useful, 
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+ * GNU General Public License for more details. 
+ * 
+ * You should have received a copy of the GNU General Public License 
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>. 
+ */
+#endregion
+using System.Runtime.Serialization;
 
-namespace HeuristicLab.Services.Authentication.DataTransfer
-{
+namespace HeuristicLab.Services.Authentication.DataTransfer {
+
   [DataContract]
-  public abstract class AuthenticationItem{
-
+  public abstract class AuthenticationItem {
 
     [DataMember]
     public System.Guid Id { get; set; }
+
+    [DataMember]
+    public string Name { get; set; }
+
+    [DataMember]
+    public string Description { get; set; }
   }
 }
Index: branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/HeuristicLab.Services.Authentication.DataTransfer.csproj
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/HeuristicLab.Services.Authentication.DataTransfer.csproj	(revision 4979)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/HeuristicLab.Services.Authentication.DataTransfer.csproj	(revision 5257)
@@ -44,5 +44,4 @@
     <Compile Include="Application.cs" />
     <Compile Include="AuthenticationItem.cs" />
-    <Compile Include="NamedAuthenticationItem.cs" />
     <Compile Include="Role.cs" />
     <Compile Include="User.cs" />
Index: branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/Role.cs
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/Role.cs	(revision 4979)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/Role.cs	(revision 5257)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab 
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * 
+ * This file is part of HeuristicLab. 
+ * 
+ * HeuristicLab is free software: you can redistribute it and/or modify 
+ * it under the terms of the GNU General Public License as published by 
+ * the Free Software Foundation, either version 3 of the License, or 
+ * (at your option) any later version. 
+ * 
+ * HeuristicLab is distributed in the hope that it will be useful, 
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+ * GNU General Public License for more details. 
+ * 
+ * You should have received a copy of the GNU General Public License 
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>. 
+ */
+#endregion
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -5,34 +25,15 @@
 using System.Runtime.Serialization;
 
-namespace HeuristicLab.Services.Authentication.DataTransfer
-{
+namespace HeuristicLab.Services.Authentication.DataTransfer {
+
   [DataContract]
-  public class Role : NamedAuthenticationItem {
+  public class Role : AuthenticationItem {
 
-      public Role()
-      {
-          Name = "";
-      }
+    public Role() {
+      ApplicationId = Guid.Empty;
+    }
 
     [DataMember]
     public Guid ApplicationId { get; set; }
-    //[DataMember]
-    //public string LoweredRoleName { get; set; } // !!! REMOVE
-    [DataMember]
-    public string Description { get; set; }
   }
-    //[DataContract]
-    //public class Role
-    //{
-    //    [DataMember]
-    //    public Guid ApplicationId { get; set; }
-    //    [DataMember]
-    //    public Guid RoleId { get; set; }
-    //    [DataMember]
-    //    public string RoleName { get; set; }
-        //[DataMember]
-        //public string LoweredRoleName { get; set; }
-    //    [DataMember]
-    //    public string Description { get; set; }
-    //}
 }
Index: branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/User.cs
===================================================================
--- branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/User.cs	(revision 4979)
+++ branches/UserManagement/HeuristicLab.Services.Authentication.DataTransfer/User.cs	(revision 5257)
@@ -1,3 +1,23 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab 
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL) 
+ * 
+ * This file is part of HeuristicLab. 
+ * 
+ * HeuristicLab is free software: you can redistribute it and/or modify 
+ * it under the terms of the GNU General Public License as published by 
+ * the Free Software Foundation, either version 3 of the License, or 
+ * (at your option) any later version. 
+ * 
+ * HeuristicLab is distributed in the hope that it will be useful, 
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+ * GNU General Public License for more details. 
+ * 
+ * You should have received a copy of the GNU General Public License 
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>. 
+ */
+#endregion
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -5,125 +25,46 @@
 using System.Runtime.Serialization;
 
-namespace HeuristicLab.Services.Authentication.DataTransfer
-{
+namespace HeuristicLab.Services.Authentication.DataTransfer {
+
   [DataContract]
-  public class User : NamedAuthenticationItem {
+  public class User : AuthenticationItem {
 
-      public User()
-      {
-          Password = "";
-          PasswordSalt = "";
-          Name = "";
-          CreateDate = DateTime.Now;
-          LastActivityDate = DateTime.Now;
-          LastLoginDate = DateTime.Now;
-          LastLockoutDate = DateTime.Now;
-          LastPasswordChangeDate = DateTime.Now;
-      }
+    public User() {
+      Name = string.Empty;
+      Email = string.Empty;
+      ApplicationId = Guid.Empty;
+      CreateDate = DateTime.Now;
+      LastActivityDate = DateTime.Now;
+      LastLoginDate = DateTime.Now;
+      LastLockoutDate = DateTime.Now;
+      LastPasswordChangeDate = DateTime.Now;
+    }
 
-    // Member of Membership
     [DataMember]
-    public Guid ApplicationId { get; set; } // Membership
+    public Guid ApplicationId { get; set; }
+
     [DataMember]
-    public string Password { get; set; } // Membership
-    //[DataMember]
-    //public string PasswordFormat { get; set; } // Membership
+    public string Email { get; set; }
+
     [DataMember]
-    public string PasswordSalt { get; set; } // Membership
-    
-    /// Change PW ?! welcher Hash in DB
+    public bool IsApproved { get; set; }
 
+    [DataMember]
+    public bool IsLookedOut { get; set; }
 
-    //[DataMember]
-    //public string MobilePIN { get; set; } // Membership
     [DataMember]
-    public string Email { get; set; } // Membership
-    //[DataMember]
-    //public string LoweredEmail { get; set; } // Membership
-    //[DataMember]
-    //public string PasswordQuestion { get; set; } // Membership
-    //[DataMember]
-    //public string PasswordAnswer { get; set; } // Membership
+    public DateTime CreateDate { get; set; }
+
     [DataMember]
-    public bool IsApproved { get; set; } // Membership
+    public DateTime LastLoginDate { get; set; }
+
     [DataMember]
-    public bool IsLookedOut { get; set; } // Membership
+    public DateTime LastPasswordChangeDate { get; set; }
+
     [DataMember]
-    public DateTime CreateDate { get; set; } // Membership
+    public DateTime LastLockoutDate { get; set; }
+
     [DataMember]
-    public DateTime LastLoginDate { get; set; } // Membership
-    [DataMember]
-    public DateTime LastPasswordChangeDate { get; set; } // Memership
-    [DataMember]
-    public DateTime LastLockoutDate { get; set; } // Membership
-    //[DataMember]
-    //public int FailedPasswordAttemptCount { get; set; } // Membership
-    //[DataMember]
-    //public DateTime FailedPasswordAttemptWindowStart { get; set; } // Membership
-    //[DataMember]
-    //public int FailedPasswordAnswerAttemptCount { get; set; } // Membership
-    //[DataMember]
-    //public DateTime FailedPasswordAnswerAttemptWindowStart { get; set; } // Membership
-    [DataMember]
-    public string Comment { get; set; } // Membership
-    // Members of User
-    //[DataMember]
-    //public string LoweredUserName { get; set; } // User
-    //[DataMember]
-    //public string MobileAlias { get; set; } // User
-    //[DataMember]
-    //public bool IsAnonymous { get; set; } // User
-    [DataMember]
-    public DateTime LastActivityDate { get; set; } // User
-
+    public DateTime LastActivityDate { get; set; }
   }
-
-
-
-    //[DataContract]
-    //public class User
-    //{
-
-    //    public User()
-    //    {
-    //        Membership = new Membership();
-    //    }
-
-    //    [DataMember]
-    //    public Membership Membership { get; set; }
-
-    //    [DataMember]
-    //    public string Email
-    //    {
-    //        get { return Membership.Email; }
-    //        set { Membership.Email = value; }
-    //    }
-    //    [DataMember]
-    //    public string Password
-    //    {
-    //        get { return Membership.Password; }
-    //        set { Membership.Password = value; }
-    //    }
-    //    [DataMember]
-    //    public string PasswordQuestion
-    //    {
-    //        get { return Membership.PasswordQuestion; }
-    //        set { this.Membership.PasswordQuestion = value; }
-    //    }
-    //    [DataMember]
-    //    public Guid ApplicationId { get; set; }
-    //    [DataMember]
-    //    public Guid UserId { get; set; }
-    //    [DataMember]
-    //    public string UserName { get; set; }
-    //    [DataMember]
-    //    public string LoweredUserName { get; set; }
-    //    [DataMember]
-    //    public string MobileAlias { get; set; }
-    //    [DataMember]
-    //    public bool IsAnonymous { get; set; }
-    //    [DataMember]
-    //    public DateTime LastActivityDate { get; set; }
-
-    //}
 }