Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AlgorithmClassController.cs
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AlgorithmClassController.cs	(revision 5241)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AlgorithmClassController.cs	(revision 5258)
@@ -8,4 +8,5 @@
 using System.ServiceModel.Security;
 using HLWebPluginHost.OKBService;
+using System.Diagnostics;
 
 namespace HLWebOKBAdminPlugin.Controllers
@@ -38,6 +39,14 @@
             //what happens: generate list of AlgorithmClass and commit the list to the index view
 
-            //get certificated service client
-            OKBService.OKBServiceClient sc = CertificateValidator();
+            
+
+            //get certificated service client
+            OKBService.OKBServiceClient sc = CertificateValidator();
+
+            var tstModel = new AlgorithmClassViewModel {
+                AlgorithmClass = new AlgorithmClass()
+            };
+
+            Debug.WriteLine("tstModel created");
 
             //get list of Algorithm Classes
@@ -68,5 +77,7 @@
             };
 
-            return View(viewModel);
+            ViewData["AlgorithmClass"] = viewModel;
+
+            return View();
         }//Details
 
@@ -87,5 +98,7 @@
             };
 
-            return View(viewModel);
+            ViewData["AlgorithmClass"] = viewModel;
+
+            return View();
         }//Create
 
@@ -120,5 +133,7 @@
                 };
 
-                return View(viewModel);
+                ViewData["AlgorithmClass"] = viewModel;
+
+                return View();
             }
         }//Create - post
@@ -139,5 +154,8 @@
                 AlgorithmClass = sc.GetAlgorithmClass(id)
             };
-            return View(viewModel);
+
+            ViewData["AlgorithmClass"] = viewModel;
+
+            return View();
         }//Edit
 
@@ -174,5 +192,7 @@
                 };
 
-                return View(viewModel);
+                ViewData["AlgorithmClass"] = viewModel;
+
+                return View();
             }
         }//Edit
@@ -193,5 +213,8 @@
                 AlgorithmClass = sc.GetAlgorithmClass(id)
             };
-            return View(viewModel);
+
+            ViewData["AlgorithmClass"] = viewModel;
+
+            return View();
         }//Delete
 
@@ -221,5 +244,7 @@
                 };
 
-                return View(viewModel);
+                ViewData["AlgorithmClass"] = viewModel;
+
+                return View();
             }
         }//Delete
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/HLWebOKBAdminPlugin.csproj
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/HLWebOKBAdminPlugin.csproj	(revision 5241)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/HLWebOKBAdminPlugin.csproj	(revision 5258)
@@ -93,4 +93,5 @@
       <DependentUpon>Global.asax</DependentUpon>
     </Compile>
+    <Compile Include="Helpers\HtmlHelpers.cs" />
     <Compile Include="Models\AccountModels.cs" />
     <Compile Include="Models\AlgorithmClassModel.cs" />
@@ -101,4 +102,5 @@
       <DependentUpon>Reference.svcmap</DependentUpon>
     </Compile>
+    <Compile Include="ViewModels\AlgorithmClassViewModel.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -126,4 +128,8 @@
       <LastGenOutput>Reference.cs</LastGenOutput>
     </None>
+    <Content Include="Views\AlgorithmClass\Create.aspx" />
+    <Content Include="Views\AlgorithmClass\Delete.aspx" />
+    <Content Include="Views\AlgorithmClass\Details.aspx" />
+    <Content Include="Views\AlgorithmClass\Edit.aspx" />
     <Content Include="Views\AlgorithmClass\Index.aspx" />
     <Content Include="Views\ServiceTest\Index.aspx" />
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Create.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Create.aspx	(revision 5258)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Create.aspx	(revision 5258)
@@ -0,0 +1,29 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Create
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Create</h2>
+
+    <% using (Html.BeginForm()) {%>
+        <%: Html.ValidationSummary(true) %>
+
+        <fieldset>
+            <legend>Create Algorithm Class</legend>
+            <%: Html.EditorFor(model => ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass)%>
+            <p>
+                <input type="submit" value="Createx" />
+            </p>
+        </fieldset>
+
+    <% } %>
+
+    <div>
+        <%: Html.ActionLink("Back to List", "Index") %>
+    </div>
+
+</asp:Content>
+
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Delete.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Delete.aspx	(revision 5258)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Delete.aspx	(revision 5258)
@@ -0,0 +1,24 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Delete
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Delete</h2>
+
+    <p>Are you sure you want to delete AlgorithmClass <strong><%: ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass.Name%></strong>?</p>
+    <fieldset>
+        <legend>Fields</legend>
+        
+    </fieldset>
+    <% using (Html.BeginForm()) { %>
+        <p>
+		    <input type="submit" value="Delete" /> |
+		    <%: Html.ActionLink("Back to List", "Index") %>
+        </p>
+    <% } %>
+
+</asp:Content>
+
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Details.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Details.aspx	(revision 5258)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Details.aspx	(revision 5258)
@@ -0,0 +1,21 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Details
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Details</h2>
+
+    <fieldset>
+        <legend>Detail AlgorithmClass</legend>
+        <%: Html.EditorFor(model => ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass)%>
+    </fieldset>
+    <p>
+        <%: Html.ActionLink("Edit", "Edit", new { id = ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass.Id })%> |
+        <%: Html.ActionLink("Back to List", "Index") %>
+    </p>
+
+</asp:Content>
+
Index: branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Edit.aspx
===================================================================
--- branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Edit.aspx	(revision 5258)
+++ branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Edit.aspx	(revision 5258)
@@ -0,0 +1,25 @@
+﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>
+
+<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
+	Edit
+</asp:Content>
+
+<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
+
+    <h2>Edit</h2>
+
+    <% using (Html.BeginForm()) {%>
+        <%: Html.ValidationSummary(true) %>
+        
+        <fieldset>
+            <legend>Edit AlgorithmClass</legend>
+            <%: Html.EditorFor(model => ((HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel)ViewData["AlgorithmClass"]).AlgorithmClass)%>
+            <p>
+                <input type="submit" value="Save" />
+            </p>
+        </fieldset>
+
+    <% } %>
+
+</asp:Content>
+
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Create.aspx
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Create.aspx	(revision 5241)
+++ 	(revision )
@@ -1,29 +1,0 @@
-﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel>" %>
-
-<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
-	Create
-</asp:Content>
-
-<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
-
-    <h2>Create</h2>
-
-    <% using (Html.BeginForm()) {%>
-        <%: Html.ValidationSummary(true) %>
-
-        <fieldset>
-            <legend>Create Algorithm Class</legend>
-            <%: Html.EditorFor(model => model.AlgorithmClass) %>
-            <p>
-                <input type="submit" value="Createx" />
-            </p>
-        </fieldset>
-
-    <% } %>
-
-    <div>
-        <%: Html.ActionLink("Back to List", "Index") %>
-    </div>
-
-</asp:Content>
-
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Delete.aspx
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Delete.aspx	(revision 5241)
+++ 	(revision )
@@ -1,24 +1,0 @@
-﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel>" %>
-
-<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
-	Delete
-</asp:Content>
-
-<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
-
-    <h2>Delete</h2>
-
-    <p>Are you sure you want to delete AlgorithmClass <strong><%: Model.AlgorithmClass.Name %></strong>?</p>
-    <fieldset>
-        <legend>Fields</legend>
-        
-    </fieldset>
-    <% using (Html.BeginForm()) { %>
-        <p>
-		    <input type="submit" value="Delete" /> |
-		    <%: Html.ActionLink("Back to List", "Index") %>
-        </p>
-    <% } %>
-
-</asp:Content>
-
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Details.aspx
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Details.aspx	(revision 5241)
+++ 	(revision )
@@ -1,21 +1,0 @@
-﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel>" %>
-
-<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
-	Details
-</asp:Content>
-
-<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
-
-    <h2>Details</h2>
-
-    <fieldset>
-        <legend>Detail AlgorithmClass</legend>
-        <%: Html.EditorFor(model => model.AlgorithmClass) %>
-    </fieldset>
-    <p>
-        <%: Html.ActionLink("Edit", "Edit", new { id=Model.AlgorithmClass.Id}) %> |
-        <%: Html.ActionLink("Back to List", "Index") %>
-    </p>
-
-</asp:Content>
-
Index: branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Edit.aspx
===================================================================
--- branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Views/AlgorithmClass/Edit.aspx	(revision 5241)
+++ 	(revision )
@@ -1,25 +1,0 @@
-﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage<HLWebOKBAdminPlugin.ViewModels.AlgorithmClassViewModel>" %>
-
-<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
-	Edit
-</asp:Content>
-
-<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
-
-    <h2>Edit</h2>
-
-    <% using (Html.BeginForm()) {%>
-        <%: Html.ValidationSummary(true) %>
-        
-        <fieldset>
-            <legend>Edit AlgorithmClass</legend>
-            <%: Html.EditorFor(model => model.AlgorithmClass) %>
-            <p>
-                <input type="submit" value="Save" />
-            </p>
-        </fieldset>
-
-    <% } %>
-
-</asp:Content>
-