Index: branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLab.Problems.DataAnalysis.Views-3.3.csproj
===================================================================
--- branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLab.Problems.DataAnalysis.Views-3.3.csproj	(revision 4327)
+++ branches/DataAnalysis/HeuristicLab.Problems.DataAnalysis.Views/3.3/HeuristicLab.Problems.DataAnalysis.Views-3.3.csproj	(revision 5265)
@@ -11,5 +11,5 @@
     <RootNamespace>HeuristicLab.Problems.DataAnalysis.Views</RootNamespace>
     <AssemblyName>HeuristicLab.Problems.DataAnalysis.Views-3.3</AssemblyName>
-    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <SignAssembly>true</SignAssembly>
@@ -34,4 +34,5 @@
     <UseApplicationTrust>false</UseApplicationTrust>
     <BootstrapperEnabled>true</BootstrapperEnabled>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -112,143 +113,97 @@
     <None Include="HeuristicLabProblemsDataAnalysisViewsPlugin.cs.frame" />
     <None Include="Properties\AssemblyInfo.frame" />
-    <Compile Include="RunCollectionValidationTrajectoryView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="RunCollectionValidationTrajectoryView.cs" />
     <Compile Include="RunCollectionValidationTrajectoryView.Designer.cs">
       <DependentUpon>RunCollectionValidationTrajectoryView.cs</DependentUpon>
     </Compile>
-    <Compile Include="RunCollectionValidationStatisticsView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="RunCollectionValidationStatisticsView.cs" />
     <Compile Include="RunCollectionValidationStatisticsView.Designer.cs">
       <DependentUpon>RunCollectionValidationStatisticsView.cs</DependentUpon>
     </Compile>
-    <Compile Include="DataAnalysisProblemDataCorrelationsView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="DataAnalysisProblemDataCorrelationsView.cs" />
     <Compile Include="DataAnalysisProblemDataCorrelationsView.Designer.cs">
       <DependentUpon>DataAnalysisProblemDataCorrelationsView.cs</DependentUpon>
     </Compile>
-    <Compile Include="RunCollectionMonteCarloVariableImpactView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="RunCollectionMonteCarloVariableImpactView.cs" />
     <Compile Include="RunCollectionMonteCarloVariableImpactView.Designer.cs">
       <DependentUpon>RunCollectionMonteCarloVariableImpactView.cs</DependentUpon>
     </Compile>
-    <Compile Include="RunCollectionWinklerVariableImpactView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="RunCollectionWinklerVariableImpactView.cs" />
     <Compile Include="RunCollectionWinklerVariableImpactView.Designer.cs">
       <DependentUpon>RunCollectionWinklerVariableImpactView.cs</DependentUpon>
     </Compile>
-    <Compile Include="DataAnalysisSolutionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="DataAnalysisSolutionView.cs" />
     <Compile Include="DataAnalysisSolutionView.Designer.cs">
       <DependentUpon>DataAnalysisSolutionView.cs</DependentUpon>
     </Compile>
-    <Compile Include="ResultsView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="ResultsView.cs" />
     <Compile Include="ResultsView.Designer.cs">
       <DependentUpon>ResultsView.cs</DependentUpon>
     </Compile>
-    <Compile Include="RunCollectionVariableImpactView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="RunCollectionVariableImpactView.cs" />
     <Compile Include="RunCollectionVariableImpactView.Designer.cs">
       <DependentUpon>RunCollectionVariableImpactView.cs</DependentUpon>
     </Compile>
-    <Compile Include="SupportVectorRegressionSolutionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="SupportVectorRegressionSolutionView.cs" />
     <Compile Include="SupportVectorRegressionSolutionView.Designer.cs">
       <DependentUpon>SupportVectorRegressionSolutionView.cs</DependentUpon>
     </Compile>
-    <Compile Include="SupportVectorMachineModelView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="SupportVectorMachineModelView.cs" />
     <Compile Include="SupportVectorMachineModelView.Designer.cs">
       <DependentUpon>SupportVectorMachineModelView.cs</DependentUpon>
     </Compile>
-    <Compile Include="EstimatedValuesView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="EstimatedValuesView.cs" />
     <Compile Include="EstimatedValuesView.Designer.cs">
       <DependentUpon>EstimatedValuesView.cs</DependentUpon>
     </Compile>
-    <Compile Include="DataAnalysisProblemDataView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="DataAnalysisProblemDataView.cs" />
     <Compile Include="DataAnalysisProblemDataView.Designer.cs">
       <DependentUpon>DataAnalysisProblemDataView.cs</DependentUpon>
     </Compile>
     <Compile Include="HeuristicLabProblemsDataAnalysisViewsPlugin.cs" />
-    <Compile Include="LineChartView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="LineChartView.cs" />
     <Compile Include="LineChartView.Designer.cs">
       <DependentUpon>LineChartView.cs</DependentUpon>
     </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="ScatterPlotView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="ScatterPlotView.cs" />
     <Compile Include="ScatterPlotView.Designer.cs">
       <DependentUpon>ScatterPlotView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Symbolic\LatexSymbolicExpressionTreeView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\LatexSymbolicExpressionTreeView.cs" />
     <Compile Include="Symbolic\LatexSymbolicExpressionTreeView.Designer.cs">
       <DependentUpon>LatexSymbolicExpressionTreeView.cs</DependentUpon>
     </Compile>
     <Compile Include="Symbolic\SymbolicExpressionTreeLatexFormatter.cs" />
-    <Compile Include="Symbolic\GraphvizSymbolicExpressionTreeView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\GraphvizSymbolicExpressionTreeView.cs" />
     <Compile Include="Symbolic\GraphvizSymbolicExpressionTreeView.Designer.cs">
       <DependentUpon>GraphvizSymbolicExpressionTreeView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Symbolic\InteractiveSymbolicRegressionSolutionSimplifierView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\InteractiveSymbolicRegressionSolutionSimplifierView.cs" />
     <Compile Include="Symbolic\InteractiveSymbolicRegressionSolutionSimplifierView.Designer.cs">
       <DependentUpon>InteractiveSymbolicRegressionSolutionSimplifierView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Symbolic\SimplifiedSymbolicExpressionModelView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\SimplifiedSymbolicExpressionModelView.cs" />
     <Compile Include="Symbolic\SimplifiedSymbolicExpressionModelView.designer.cs">
       <DependentUpon>SimplifiedSymbolicExpressionModelView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Symbolic\SymbolicExpressionModelView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\SymbolicExpressionModelView.cs" />
     <Compile Include="Symbolic\SymbolicExpressionModelView.designer.cs">
       <DependentUpon>SymbolicExpressionModelView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Symbolic\SymbolicRegressionSolutionView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\SymbolicRegressionSolutionView.cs" />
     <Compile Include="Symbolic\SymbolicRegressionSolutionView.Designer.cs">
       <DependentUpon>SymbolicRegressionSolutionView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Symbolic\Symbols\ConstantView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\Symbols\ConstantView.cs" />
     <Compile Include="Symbolic\Symbols\ConstantView.Designer.cs">
       <DependentUpon>ConstantView.cs</DependentUpon>
     </Compile>
-    <Compile Include="Symbolic\Symbols\LaggedVariableView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\Symbols\LaggedVariableView.cs" />
     <Compile Include="Symbolic\Symbols\LaggedVariableView.Designer.cs">
       <DependentUpon>LaggedVariableView.cs</DependentUpon>
     </Compile>
     <Compile Include="Symbolic\SymbolicExpressionTreeGraphvizFormatter.cs" />
-    <Compile Include="Symbolic\Symbols\VariableView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
+    <Compile Include="Symbolic\Symbols\VariableView.cs" />
     <Compile Include="Symbolic\Symbols\VariableView.Designer.cs">
       <DependentUpon>VariableView.cs</DependentUpon>
@@ -256,76 +211,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
-      <Project>{887425B4-4348-49ED-A457-B7D2C26DDBF9}</Project>
-      <Name>HeuristicLab.Analysis-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
-      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
-      <Name>HeuristicLab.Collections-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
-      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
-      <Name>HeuristicLab.Common-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
-      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
-      <Name>HeuristicLab.Core.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
-      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
-      <Name>HeuristicLab.Core-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Data.Views\3.3\HeuristicLab.Data.Views-3.3.csproj">
-      <Project>{72104A0B-90E7-42F3-9ABE-9BBBADD4B943}</Project>
-      <Name>HeuristicLab.Data.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Data\3.3\HeuristicLab.Data-3.3.csproj">
-      <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
-      <Name>HeuristicLab.Data-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views\3.3\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.3.csproj">
-      <Project>{6F42C5F8-16CD-43EE-8208-FD4573A69D85}</Project>
-      <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding\3.3\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj">
-      <Project>{125D3006-67F5-48CB-913E-73C0548F17FA}</Project>
-      <Name>HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.ExtLibs\HeuristicLab.ALGLIB\2.5.0\ALGLIB-2.5.0\ALGLIB-2.5.0.csproj">
-      <Project>{29E4B033-1FEF-4FE1-AE17-0A9319D7C54E}</Project>
-      <Name>ALGLIB-2.5.0</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.3\HeuristicLab.MainForm.WindowsForms-3.3.csproj">
-      <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
-      <Name>HeuristicLab.MainForm.WindowsForms-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm\3.3\HeuristicLab.MainForm-3.3.csproj">
-      <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
-      <Name>HeuristicLab.MainForm-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Operators\3.3\HeuristicLab.Operators-3.3.csproj">
-      <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
-      <Name>HeuristicLab.Operators-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Optimization.Views\3.3\HeuristicLab.Optimization.Views-3.3.csproj">
-      <Project>{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}</Project>
-      <Name>HeuristicLab.Optimization.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
-      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
-      <Name>HeuristicLab.Optimization-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
-      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
-      <Name>HeuristicLab.Parameters-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
-      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
-      <Name>HeuristicLab.Persistence-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
-      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
-      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Regression\3.3\HeuristicLab.Problems.DataAnalysis.Regression-3.3.csproj">
       <Project>{BDF86B1D-630E-4CE2-8A49-8C90B1BDE4C9}</Project>